package ru.amse.kanzheleva.moviemaker.movie.figures;

import ru.amse.kanzheleva.moviemaker.movie.ColorRGB;
import ru.amse.kanzheleva.moviemaker.movie.IVisitor;
import ru.amse.kanzheleva.moviemaker.movie.MyPoint;

public class Polygon extends PolyFigure implements IPolygon {

	public Polygon() {
		
	}
	
	public Polygon(ColorRGB lineColor, ColorRGB fillColor,
			int[] x, int[] y,
			double rotationAhgle,
			int xRotationCenter, int yRotationCenter) {

		ColorRGB newLineColor = new ColorRGB(lineColor.getRed(), lineColor.getGreen(), 
				lineColor.getBlue());
		setLineColor(newLineColor);
		ColorRGB newFillColor = new ColorRGB(fillColor.getRed(), fillColor.getGreen(), 
				fillColor.getBlue());
		setFillColor(newFillColor);
		
		setX(x);
		setY(y);
		
		MyPoint rotationPoint = new MyPoint(xRotationCenter, yRotationCenter);
		setRotationAngle(rotationAhgle);
		setRotationCenter(rotationPoint);
	}
	
	public <R, P> R visit(IVisitor<R, P> dr, P attributes) {
		return dr.visit(this, attributes);
	}
	
}
