package ru.amse.kanzheleva.moviemaker.movie.figures;

import ru.amse.kanzheleva.moviemaker.movie.ColorRGB;
import ru.amse.kanzheleva.moviemaker.movie.IVisitor;
import ru.amse.kanzheleva.moviemaker.movie.MyPoint;

public class RoundRectangle extends RectangularFigure implements IRoundRectangle {
	private int myCurveWidth;
	private int myCurveHeight;
		
	public RoundRectangle() {
		
	}
	
	public RoundRectangle(ColorRGB lineColor, ColorRGB fillColor,
			int xPosition, int yPosition, 
			int width, int height,
			int curveWidth, int curveHeight,
			double rotationAhgle, 
			int xRotationCenter, int yRotationCenter) {
		
		ColorRGB newLineColor = new ColorRGB(lineColor.getRed(), lineColor.getGreen(), 
				lineColor.getBlue());
		setLineColor(newLineColor);
		ColorRGB newFillColor = new ColorRGB(fillColor.getRed(), fillColor.getGreen(), 
				fillColor.getBlue());
		setFillColor(newFillColor);
		
		MyPoint rectanglePoint = new MyPoint(xPosition, yPosition);
		setPosition(rectanglePoint);
		
		setWidth(width);
		setHeight(height);
		setCurveWidth(curveWidth);
		setCurveHeight(curveHeight);
		
		MyPoint rotationPoint = new MyPoint(xRotationCenter, yRotationCenter);
		setRotationAngle(rotationAhgle);
		setRotationCenter(rotationPoint);
	}

	
	public int getCurveWidth() {
		return myCurveWidth;
	}
	
	public int getCurveHeight() {
		return myCurveHeight;
	}
		
	public void setCurveWidth(int curveWidth) {
		myCurveWidth = curveWidth;
	}
	
	public void setCurveHeight(int curveHeight) {
		myCurveHeight = curveHeight;
	}
	
	public <R, P> R visit(IVisitor<R, P> dr, P attributes) {
		return dr.visit(this, attributes);
	}
}
