package ru.amse.kanzheleva.moviemaker.ui.frame;

import java.util.LinkedList;
import java.util.List;

import ru.amse.kanzheleva.moviemaker.movie.IMyPoint;
import ru.amse.kanzheleva.moviemaker.movie.IVisitor;
import ru.amse.kanzheleva.moviemaker.movie.MovePoint;
import ru.amse.kanzheleva.moviemaker.movie.Moviable;
import ru.amse.kanzheleva.moviemaker.movie.MyPoint;
import ru.amse.kanzheleva.moviemaker.movie.figures.IEllipse;
import ru.amse.kanzheleva.moviemaker.movie.figures.IPolyFigure;
import ru.amse.kanzheleva.moviemaker.movie.figures.IPolyLine;
import ru.amse.kanzheleva.moviemaker.movie.figures.IPolygon;
import ru.amse.kanzheleva.moviemaker.movie.figures.IRectangle;
import ru.amse.kanzheleva.moviemaker.movie.figures.IRectangularFigure;
import ru.amse.kanzheleva.moviemaker.movie.figures.IRoundRectangle;

public class MovePointsListMaker implements IVisitor<List<Moviable>, Void>{
	private static MovePointsListMaker myInstance;
	
	private MovePointsListMaker() {
	}
	
	public static MovePointsListMaker getInstance() {
		if (myInstance == null) {
			myInstance = new MovePointsListMaker();
		}
		return myInstance;
	}
	
	public List<Moviable> visit(IRectangle rectangle, Void attributes) {
		List<Moviable> movePoints = new LinkedList<Moviable>();
		fillForRectangularFigures(movePoints, rectangle);
		return movePoints;
	}

	public List<Moviable> visit(IRoundRectangle rectangle, Void attributes) {
		List<Moviable> movePoints = new LinkedList<Moviable>();
		fillForRectangularFigures(movePoints, rectangle);
		return movePoints;
	}

	public List<Moviable> visit(IEllipse ellipse, Void attributes) {
		List<Moviable> movePoints = new LinkedList<Moviable>();
		fillForRectangularFigures(movePoints, ellipse);
		return movePoints;
	}

	public List<Moviable> visit(IPolygon polygon, Void attributes) {
		List<Moviable> movePoints = new LinkedList<Moviable>();
		fillForPolyFigyre(movePoints, polygon);
		return movePoints;	
	}
	
	public List<Moviable> visit(IPolyLine polyLine, Void attributes) {
		List<Moviable> movePoints = new LinkedList<Moviable>();
		fillForPolyFigyre(movePoints, polyLine);
		return movePoints;
	}

	public List<Moviable> visit(Moviable element, Void attributes) {
		return null;
	}
	
	private void fillForRectangularFigures(List<Moviable> movePoints, IRectangularFigure figure) {
		IMyPoint position = figure.getPosition();
		int width = figure.getWidth();
		int height = figure.getHeight();
		Moviable movePoint1 = new MovePoint();
		movePoint1.setPosition(new MyPoint(position.getX(), position.getY()));
		movePoints.add(movePoint1);
		
		Moviable movePoint2 = new MovePoint();
		movePoint2.setPosition(new MyPoint(position.getX() + width, position.getY()));
		movePoints.add(movePoint2);
		
		Moviable movePoint3 = new MovePoint();
		movePoint3.setPosition(new MyPoint(position.getX() + width, position.getY() + height));
		movePoints.add(movePoint3);
		
		Moviable movePoint4 = new MovePoint();
		movePoint4.setPosition(new MyPoint(position.getX(), position.getY() + height));
		movePoints.add(movePoint4);	
	}
	
	private void fillForPolyFigyre(List<Moviable> movePoints, IPolyFigure polyFigure) {
		int[] x = polyFigure.getX();
		int[] y = polyFigure.getY();
		int length = x.length;
		for (int i = 0; i < length; i++) {
			Moviable movePointi = new MovePoint();
			movePointi.setPosition(new MyPoint(x[i], y[i]));
			movePoints.add(movePointi);
		}		
	}
}
