package ru.amse.kanzheleva.moviemaker.ui.frame.actions;

import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.AbstractAction;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

import ru.amse.kanzheleva.moviemaker.ui.frame.FrameMaker;

public class EditOpenAction extends AbstractAction {
	private static final long serialVersionUID = 1L;
	private FrameMaker myParent;
			
	public EditOpenAction(FrameMaker parent) {
		super();
		myParent = parent;		
	}

	public void actionPerformed(ActionEvent e) {
		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setFileFilter(new FileFilter() {
			@Override
			public boolean accept(File f) {
				if (f.isDirectory() || f.getName().toLowerCase().endsWith(".xml")) {
					return true;
				} 
				return false;
			}

			@Override
			public String getDescription() {
				return ".xml files";
			}
			
		});
		fileChooser.showOpenDialog(null);
		File openFile = fileChooser.getSelectedFile();
		if (openFile != null) {
			if (!openFile.getName().toLowerCase().endsWith(".xml")) {
				JOptionPane.showMessageDialog(null, "wrong expansion");
				return;
			}
			myParent.openNewMovie(openFile);
		}
		
	}
	
}
