package ru.amse.kanzheleva.moviemaker.ui.previewpane;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.MouseEvent;
import java.awt.geom.Rectangle2D;

import javax.swing.SwingUtilities;
import javax.swing.event.MouseInputAdapter;

import ru.amse.kanzheleva.moviemaker.movie.IFrame;
import ru.amse.kanzheleva.moviemaker.ui.frame.JDrawer;

public class Thumbnail extends JDrawer {
	private static final long serialVersionUID = 1L;
	private PreviewPane myParent;
	private int myFrameNumber;
		
	public Thumbnail(PreviewPane parent, IFrame frame, int width, int height, double xScale, double yScale, int frameNumber) {
		super(frame, width, height, xScale, yScale);
		myParent = parent;
		myFrameNumber = frameNumber;
		addMouseListener(new MouseListener());
	}
	
	public int getFrameNumber() {
		return myFrameNumber;
	}
	
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		if (myParent.isThisChoosen(this)) {
			Graphics2D g2 = (Graphics2D) g;
			g2.setColor(new Color(0, 0, 140));			
			drawBorder(g2);
		}
	}
	
	private void drawBorder(Graphics2D g2) {
		g2.draw(new Rectangle2D.Double(0, 0, myWidth, myHeight));
		g2.draw(new Rectangle2D.Double(1, 1, myWidth - 1, myHeight - 1));
		g2.draw(new Rectangle2D.Double(2, 2, myWidth - 2, myHeight - 2));
		g2.draw(new Rectangle2D.Double(3, 3, myWidth - 3, myHeight - 3));
	}
	
		
	/**/
	public class MouseListener extends MouseInputAdapter {
		@Override
		public void mouseClicked(MouseEvent e) {
			if (SwingUtilities.isLeftMouseButton(e)) {
				myParent.Choose(Thumbnail.this);
			} 
		}
	}
}
