package ru.amse.kanzheleva.moviemaker.xml;

import org.xml.sax.Attributes;

import ru.amse.kanzheleva.moviemaker.movie.ColorRGB;
import ru.amse.kanzheleva.moviemaker.movie.IGraphicalObject;
import ru.amse.kanzheleva.moviemaker.movie.IMyPoint;
import ru.amse.kanzheleva.moviemaker.movie.MyPoint;

public class GraphicalObjectReader {
	public static void read(Attributes attributes, IGraphicalObject figure) {
		ColorRGB fillColor = new ColorRGB(
				Integer.valueOf(attributes.getValue(MovieConstants.FILLRED)),
				Integer.valueOf(attributes.getValue(MovieConstants.FILLGREEN)),
				Integer.valueOf(attributes.getValue(MovieConstants.FILLBLUE)));
		figure.setFillColor(fillColor);
		
		ColorRGB lineColor = new ColorRGB(
				Integer.valueOf(attributes.getValue(MovieConstants.LINERED)),
				Integer.valueOf(attributes.getValue(MovieConstants.LINEGREEN)),
				Integer.valueOf(attributes.getValue(MovieConstants.LINEBLUE)));
		figure.setLineColor(lineColor);
		
		double rotationAngle = Double.valueOf(attributes.getValue(MovieConstants.ROTATIONANGLE));
		figure.setRotationAngle(rotationAngle);
		
		IMyPoint rotationCenter = new MyPoint(
				Integer.valueOf(attributes.getValue(MovieConstants.XCENTER)),
				Integer.valueOf(attributes.getValue(MovieConstants.YCENTER)));
		figure.setRotationCenter(rotationCenter);
	}
}
